/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.supinfo.spitfireboard.jpa;

import com.supinfo.spitfireboard.dao.BoardDao;
import com.supinfo.spitfireboard.entities.Board;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

/**
 *
 * @author Fabien LOISON
 */
@Stateless
public class JpaBoardDao implements BoardDao {
    @PersistenceContext
    private EntityManager em;
    
    @Override
    public Board getById(Long id) {
        CriteriaBuilder builder = em.getCriteriaBuilder();
        CriteriaQuery<Board> query = builder.createQuery(Board.class);
        Root<Board> board = query.from(Board.class);
        query.where(builder.equal(board.get("id"), id));
        return em.createQuery(query).getSingleResult();
    }
    
    @Override
    public Long persistBoard(Board board) {
        em.persist(board);
        em.flush();
        return board.getId();
    }
    
    @Override
    public void delete(Long id) {
        Board board = this.getById(id);
        em.remove(board);
    }
}
