/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.supinfo.spitfireboard.servlets;

import com.supinfo.spitfireboard.entities.Category;
import com.supinfo.spitfireboard.services.ForumService;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

/**
 *
 * @author Fabien LOISON
 */
@ManagedBean
@RequestScoped
public class CategoryController {
    
    @EJB
    private ForumService forumService;

    /**
     * Creates a new instance of boardController
     */
    public CategoryController() {
    }
    
    private Long getCategoryId() {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        String idStr = (String) facesContext.getExternalContext().getRequestParameterMap().get("id");
        if (idStr == null) {
            return null;
        }
        return Long.valueOf(idStr);
    }
    
    private String getValue(String fieldName) {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        return (String) facesContext.getExternalContext().getRequestParameterMap().get(fieldName);
    }
    
    public Category getCategory() {
        return forumService.getCategory(this.getCategoryId());
    }
    
    public List<String> doDelete() {
        List<String> errors = new ArrayList<String>();
        
        try {
            forumService.deleteCategory(Long.valueOf(this.getValue("categoryId")));
        }
        catch (Exception ex) {
            errors.add("Oops! Something wrong appened.");
            return errors;
        }
        
        // Redirect
        ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
        try {
            context.redirect("index.xhtml");
        } catch (IOException ex) {
            Logger.getLogger(CategoryController.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return null;
    }
    
    public List<String> doEdit() {
        List<String> errors = new ArrayList<String>();
        
        try {
            forumService.categoryEdit(Long.valueOf(this.getValue("categoryId")), this.getValue("title"));
        }
        catch (Exception ex) {
            errors.add("Oops! Something wrong appened.");
            return errors;
        }
        
        // Redirect
        ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
        try {
            context.redirect("index.xhtml");
        } catch (IOException ex) {
            Logger.getLogger(CategoryController.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return null;
    }
    
    
    
    public List<String> doNewBoard() {
        List<String> errors = new ArrayList<String>();
        
        // Check for empty fields
        if (this.getValue("title").equals("")) {
            errors.add("The 'Title' field is empty");
        }
        
        // No error...
        if (errors.isEmpty()) {
            Long topicId = null;
            try {
                topicId = forumService.newBoard(this.getValue("title"), Long.valueOf(this.getValue("categoryId")));
            }
            catch (Exception ex) {
                errors.add("Oops! Something wrong appened.");
                return errors;
            }
            
            // Redirect
            ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
            try {
                context.redirect("index.xhtml");
            } catch (IOException ex) {
                Logger.getLogger(CategoryController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        
        return errors;
    }
    
    
    
    public List<String> doNew() {
        List<String> errors = new ArrayList<String>();
        
        // Check for empty fields
        if (this.getValue("title").equals("")) {
            errors.add("The 'Title' field is empty");
        }
        
        // No error...
        if (errors.isEmpty()) {
            Long categoryId = null;
            try {
                categoryId = forumService.newCategory(this.getValue("title"));
            }
            catch (Exception ex) {
                errors.add("Oops! Something wrong appened.");
                return errors;
            }
            
            // Redirect
            ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
            try {
                context.redirect("index.xhtml");
            } catch (IOException ex) {
                Logger.getLogger(CategoryController.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        
        return errors;
    }
    
}
